﻿/* =========================================================================

NAME: megaBorder+PL

AUTHOR: Oleg Butrin (obutrin@indesign.rudtp.ru)
HOMEPAGE: http://indesign.rudtp.ru
DATE  : 26.11.2004 15:56



COMMENT:
Script make border around paragraph with custom paragraph style applied

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

*******************************************************************************
Примазался к авторству Андрей Рыжков (ragman) special946@gmail.com

Вместо выбора стиля абзаца и стиля рамки сделан выбор "плей листа" - файла с прописанным
соответствием стиля рамки стилю абзаца. Для создания "илей листа" скрипт необходимо запустить
без выделения чего либо. 

В настройках рамки добавлены запоминание высоты и вертикального выравнивания текста.

Внесены исправления для работы в InDesignCS2.
*******************************************************************************

============================================================================ */
//ФУНКЦИИ
//Определение объекта
function tablePreset(myTable) {
//если есть параметр, то пишем свойства объекта
	if (myTable != null) {
		var myCell = myTable.cells[0];
		with (myCell) {
			this.strokeColor = new Array(topEdgeStrokeColor.name, bottomEdgeStrokeColor.name, leftEdgeStrokeColor.name, rightEdgeStrokeColor.name);
			this.strokeTint = new Array(topEdgeStrokeTint, bottomEdgeStrokeTint, leftEdgeStrokeTint, rightEdgeStrokeTint);
			this.strokeType = new Array(topEdgeStrokeType.name, bottomEdgeStrokeType.name, leftEdgeStrokeType.name, rightEdgeStrokeType.name);
			this.strokeWeight = new Array(topEdgeStrokeWeight, bottomEdgeStrokeWeight, leftEdgeStrokeWeight, rightEdgeStrokeWeight);
			this.inset = new Array(topInset, bottomInset, leftInset, rightInset);
			this.color = fillColor.name;
			this.tint = fillTint;
			this.height = height; // *** введена высота ячейки ***
			this.verticalJustification = verticalJustification; // *** введено вертикальное выравнивание текста ***
		}
		var myObject = myTable;
		while (myObject.constructor.name != "Document") {
			var myObject = myObject.parent;
		}
		this.vertMeasurement = myObject.viewPreferences.verticalMeasurementUnits;
		this.horizMeasurement = myObject.viewPreferences.horizontalMeasurementUnits;
//если нет параметра - пишем пустые свойства		
	} else {
		this.strokeColor = "";
		this.strokeTint = "";
		this.strokeType = "";
		this.strokeWeight = "";
		this.inset = "";
		this.color = "";
		this.tint = "";
		this.vertMeasurement = "";
		this.horizMeasurement = "";
		this.height = ""; // *** веедена высота ячейки ***
		this.verticalJustification = ""; // *** введено вертикальное выравнивание текста ***
	}
}
//Применение объекта к параграфу
function applyPreset (myParagraph, mySpaceBefore, mySpaceAfter) {
//При нулевом параграфе возвращаем нуль
	if (myParagraph == null) {
		return null;
	}
//Ищем по параграфу документ
	var myObject = myParagraph.parentStory;
	while (myObject.constructor.name != "Document") {
		var myObject = myObject.parent;
	}
//Применяем юниты из объекта к линейкам	
	var myVM = myObject.viewPreferences.verticalMeasurementUnits;
	var myHM = myObject.viewPreferences.horizontalMeasurementUnits;
	myObject.viewPreferences.verticalMeasurementUnits = myPreset.vertMeasurement;
	myObject.viewPreferences.horizontalMeasurementUnits = myPreset.horizMeasurement;
//Помещаем таблицу с заданными свойствами в параграф
	var myTable = myParagraph.tables.add(LocationOptions.atBeginning, undefined,
		{
			columnCount:1,
			bodyRowCount:1,
			headerRowCount:0,
			footerRowCount:0,
			topBorderStrokeColor:myObject.colors.item(String(this.strokeColor[0])),
			bottomBorderStrokeColor:myObject.colors.item(String(this.strokeColor[1])),
			leftBorderStrokeColor:myObject.colors.item(String(this.strokeColor[2])),
			rightBorderStrokeColor:myObject.colors.item(String(this.strokeColor[3])),
			topBorderStrokeTint:Number(this.strokeTint[0]),
			bottomBorderStrokeTint:Number(this.strokeTint[1]),
			leftBorderStrokeTint:Number(this.strokeTint[2]),
			rightBorderStrokeTint:Number(this.strokeTint[3]),
			topBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[0])),
			bottomBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[1])),
			leftBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[2])),
			rightBorderStrokeType:myObject.strokeStyles.item(String(this.strokeType[3])),
			topBorderStrokeWeight:Number(this.strokeWeight[0]),
			bottomBorderStrokeWeight:Number(this.strokeWeight[1]),
			leftBorderStrokeWeight:Number(this.strokeWeight[2]),
			rightBorderStrokeWeight:Number(this.strokeWeight[3])
		}
	);
//Обрабатываем ячейку
	var myCell = myTable.cells[0];
	with (myCell) {
		topInset = Number(this.inset[0]);
		bottomInset = Number(this.inset[1]);
		leftInset = Number(this.inset[2]);
		rightInset = Number(this.inset[3]);
		fillColor = myObject.colors.item(this.color);
		fillTint = Number(this.tint);
		height = this.height; // *** добавлеа высота ***
		verticalJustification = this.verticalJustification; // *** введено вертикальное выравнивание текста ***
	}
//Определяем текст параграфа
	var myText = myParagraph.characters.itemByRange(1, (myParagraph.characters.length - 2));
//Юниты - в исходное
	myObject.viewPreferences.verticalMeasurementUnits = myVM;
	myObject.viewPreferences.horizontalMeasurementUnits = myHM;	
//Расстояния до и после(не определяем при помещении таблицы потому, что юниты)
	myTable.spaceBefore = mySpaceBefore;
	myTable.spaceAfter = mySpaceAfter;
//Выделяем текст
	myText.select(1919250519);
//Вырезаем текст
	app.cut();
//Выделяем ячейку
	myCell.insertionPoints[0].select(1919250519);
//Вставляем текст
	app.paste();
}
tablePreset.prototype.applyPreset = applyPreset;

//Функция проверки объекта
function checkPreset(myDoc) {
	var myResult = true;
//Пробуем цвета, стили
	for (myCounter = 0; myCounter < this.strokeColor.length; myCounter++) {
		try {
			if (this.color != "None") {
				var myCheck = myDoc.colors.item(this.color);
				var myCheckName = myCheck.name;
			}
		} catch (error) {
			myResult = false;
		}
	}
	for (myCounter = 0; myCounter < this.strokeType.length; myCounter++) {
		try {
			var myCheck = myDoc.strokeStyles.item(this.strokeType[myCounter]);
			var myCheckName = myCheck.name;
		} catch (error) {
			myResult = false;
		}
	}
	try {
		if (this.color != "None") {
			var myCheck = myDoc.colors.item(this.color);
			var myCheckName = myCheck.name;
		}
	} catch (error) {
		myResult = false;
	}
	return myResult;
}
tablePreset.prototype.checkPreset = checkPreset;

//Функция записи файла
function writeFile(myFile) {
	var myResult = myFile.open("w");
	if (!myResult) {
		alert(langNotOpenWrite);
		exit();
	}
	var myString = "";
	for (var field in this) {
		if (typeof(this[field]) != "function") {
			myString += field + "%|%" + typeof(this[field]) + "%|%" + this[field] + "\n";
		}
	}
	myFile.write(myString);
	myFile.close();
}
tablePreset.prototype.writeFile = writeFile;

//Функция чтения файла
function readFile(myFile) {
	var myResult = myFile.open("r");
	if (!myResult) {
		alert(langNotOpenRead);
		exit();
	}
	var myArray = new Array();
	var myCounter = 0
	while (!myFile.eof) {
		myArray[myCounter] = myFile.readln().split("%|%");
		myCounter++;
	}
	myFile.close();
//Обработка строк
	for (myCounter = 0; myCounter < myArray.length; myCounter++) {
		switch (myArray[myCounter][1]) {
			case "number":
				this[String(myArray[myCounter][0])] = Number(myArray[myCounter][2]);
			break;
			case "string":
				this[String(myArray[myCounter][0])] = String(myArray[myCounter][2]);
			break;
			case "object":
				this[String(myArray[myCounter][0])] = (myArray[myCounter][2]).split(",");
			break;
		}
	}
}
//Функция записи файла PL
function writeFilePL(myFile, myAddString) {
	var myResult = myFile.open("r");

	var myString = myFile.read();
	myString = myString + myAddString;
	var myResult = myFile.open("w");
	if (!myResult) {
		alert(langNotOpenRead);
		exit();
	}
	myFile.write(myString);
	myFile.close();
}
//Функция чтения файла PL
function readFilePL(myFile) {
	var myResult = myFile.open("r");
	if (!myResult) {
		alert(langNotOpenRead);
		exit();
	}
	var myArray = new Array();
	var myCounter = 0
	while (!myFile.eof) {
		myArray[myCounter] = myFile.readln().split("%|%");
		myCounter++;
	}
	myFile.close();
	return myArray;
}
tablePreset.prototype.readFile = readFile;

//Функция проверки имени файла
function fileNameCheck (myFile, myExt) {
	var myPath = app.activeScript.path;
	var myName = myFile.name;
	if (myName.substring((myName.length - myExt.length), ) != myExt) {
		myName +=myExt;
	}
	return new File (myPath + "/" + myName);
}

//Функция получения списка файлов
function getNameOfFiles(myArray) {
	var myResult = new Array();
	for (myCounter = 0; myCounter < myArray.length; myCounter++) {
		var myFile = new File (myArray[myCounter]);
		myResult[myCounter] = myFile.name;
	}
	return myResult;
}

//ОСНОВНАЯ ЧАСТЬ
with (app) {
//Подключаем ini-файл и языковой модуль
	var myIniFile = new File (activeScript.path + "/megaBorder+PL.ini");
	if (!myIniFile.exists) {
		alert("Can\'t find ini file!");
		exit ();
	} else {
		eval ("//@include \'megaBorder+PL.ini\';");
	}
	var myLangFile = new File (activeScript.path + "/" + iniLangFile);
	if (!myLangFile.exists) {
		alert("Can\'t find lang file!");
		exit ();
	} else {
		eval ("//@include \'" + iniLangFile + "\';");
	}
//Проверка документа	
	if (documents.length < 1) {
		alert(langNoDoc);
		exit();
	}
	var myDoc = activeDocument;
//Проверка выделенного
	if (selection.length != 1) {
	//Если ничего не выделено, будем создавать плей-лист
	//Получаем список стилей	
		var myStyleNames = new Array();
		for (myCounter = 0; myCounter < myDoc.paragraphStyles.length; myCounter++) {
			myStyleNames[myCounter] = myDoc.paragraphStyles[myCounter].name;
		}
	//Получаем список файлов	
		var myFolder = new Folder(activeScript.path);
		var myPresetFiles = myFolder.getFiles("*.borderpres");
		if (myPresetFiles.length < 1) {
			alert(langNoPresets);
			exit();
		}
	//Получаем список имен файлов	
		var myPresetNames = getNameOfFiles(myPresetFiles);
	// Диалог	
		var myDialog = dialogs.add({name:iniScriptName + " " + iniScriptVersion + ": создание плей-листа"});
		with (myDialog.dialogColumns.add()) {
			with (dialogRows.add().borderPanels.add().dialogColumns.add()) {
				dialogRows.add().staticTexts.add({staticLabel:langSelectStyle});
				var mySelectStyle = dialogRows.add().dropdowns.add({stringList:myStyleNames, selectedIndex:0});
				dialogRows.add().staticTexts.add({staticLabel:langSelectPreset});
				var mySelectPreset = dialogRows.add().dropdowns.add({stringList:myPresetNames, selectedIndex:0});
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						dialogRows.add().staticTexts.add({staticLabel:langSpaceBefore});
						dialogRows.add().staticTexts.add({staticLabel:langSpaceAfter});
					}
					with (dialogColumns.add()) {
						var mySelectSpaceBefore = dialogRows.add().measurementEditboxes.add({editUnits:myDoc.viewPreferences.horizontalMeasurementUnits, minimumValue:0, maximumValue:72, largeNudge:0.1, smallNudge:0.1, editContents:iniSpaceBefore});
						var mySelectSpaceAfter = dialogRows.add().measurementEditboxes.add({editUnits:myDoc.viewPreferences.horizontalMeasurementUnits, minimumValue:0, maximumValue:72, largeNudge:0.1, smallNudge:0.1, editContents:iniSpaceAfter});
					}
				}
			}
			with (dialogRows.add().dialogColumns.add()) {
				dialogRows.add().staticTexts.add({staticLabel:"\u00A9 Oleg Butrin + ragman"});
				dialogRows.add().staticTexts.add({staticLabel:"http://indesign.rudtp.ru"});
			}

		}
	//Показываем диалог
		var myResult = myDialog.show();
		if (!myResult) {
			myDialog.destroy();
			exit();
		}
		var myNewString = myDoc.paragraphStyles[mySelectStyle.selectedIndex].name + "%|%" + myPresetNames[mySelectPreset.selectedIndex] + "%|%" + mySelectSpaceBefore.editContents.substring(0, (mySelectSpaceBefore.editContents.length - 3)) + "%|%" + mySelectSpaceAfter.editContents.substring(0, (mySelectSpaceAfter.editContents.length - 3)) + "\n";
		Folder.current = activeScript.path;
//Сохраняем
		var myFile = File.saveDialog(iniScriptName + " " + iniScriptVersion + ". " + langSavePL, iniFileTypePL);
		if (!myFile) {
			alert(langNoSelectFile);
			exit();
		}
		myFile = fileNameCheck(myFile, ".border_pl");
		writeFilePL(myFile, myNewString);
		alert(langPresetSaved);
		exit();
	}
//Проверка на выделенную таблицу
	if ((selection[0].parent.constructor.name == "Cell") || (selection[0].parent.constructor.name == "Table")) {
//Запрос на сохранение
		var myResult = confirm(langTableSelected);
		if (myResult) {
			var myObject = selection[0];
			while (myObject.constructor.name != "Table") {
				var myObject = myObject.parent;
			}
//Определяем объект
			var myPreset = new tablePreset(myObject);
			Folder.current = activeScript.path;
//Сохраняем
			var myFile = File.saveDialog(iniScriptName + " " + iniScriptVersion + ". " + langSavePreset, iniFileType);
			if (!myFile) {
				alert(langNoSelectFile);
				exit();
			}
			myFile = fileNameCheck(myFile, ".borderpres");
			myPreset.writeFile(myFile);
			alert(langPresetSaved);
			exit();
		}
	}
//Определяем текст
	switch (selection[0].constructor.name) {
		case "InsertionPoint":
			var myStory = selection[0].parentStory;
			break;
		case "Text":
			var myStory = selection[0].parentStory;
			break;
		case "TextFrame":
			var myStory = selection[0];
			break;
		case "Cell":
			var myStory = selection[0].parent.parent.parentStory;
			break;
		default:
			alert(langNoSelection);
			exit();
	}
//============================ Получаем плей-лист
//Получаем список файлов PL	
	var myFolder = new Folder(activeScript.path);
	var myPLFiles = myFolder.getFiles("*.border_pl");
	if (myPLFiles.length < 1) {
		alert(langNoPL);
		exit();
	}
//Получаем список имен файлов	
	var myPLNames = getNameOfFiles(myPLFiles);
	
//Диалог
	var myDialog = dialogs.add({name:iniScriptName + " " + iniScriptVersion});
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:"Выберите файл настроек:"});
			var mySelectPL = dialogRows.add().dropdowns.add({stringList:myPLNames, selectedIndex:0});
			var myRemoveBorders = dialogRows.add().checkboxControls.add({staticLabel:langRemoveBorders, checkedState:false});

		}
		with (dialogRows.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:"\u00A9 Oleg Butrin + ragman"});
			dialogRows.add().staticTexts.add({staticLabel:"http://indesign.rudtp.ru"});
		}
	}
	var myResult = myDialog.show();
	if (!myResult) {
		myDialog.destroy();
		exit();
	}
	var myPL = myPLNames[mySelectPL.selectedIndex];

//Читаем плей-лист
	var myPLFile = new File (activeScript.path + '/' + myPL);
	myPL = readFilePL(myPLFile);
//============================ Получаем плей-лист

//Убираем бордеры у ВСЕХ абзацев
	if (myRemoveBorders.checkedState) {
		var myTables = new Array();
		for (myCounter = 0; myCounter < myStory.tables.length; myCounter++) {
			myTables[myCounter] = myStory.tables[myCounter]
		}
		
		myTables.reverse();
		for (myCounter = 0; myCounter < myTables.length; myCounter++) {
			var myTable = myTables[myCounter];
				myTable.convertToText();
		}
		if (iniSaveDocumentOnEnd) {
			myDoc.save(myDoc.fullName);
		}
		myDialog.destroy();
		exit();
	}

	for (plCounter = 0; plCounter < myPL.length - 1; plCounter++) {
		var myStyle = myPL[plCounter][0];
		var mySelectSpaceBefore = myPL[plCounter][2];
		var mySelectSpaceAfter = myPL[plCounter][3];
		
//Определяем и проверяем объект
	var myPreset = new tablePreset();
	var myPresetFiles = new File (activeScript.path + "/" + myPL[plCounter][1]);
	myPreset.readFile(myPresetFiles);
	if (!myPreset.checkPreset(myDoc)) {
		alert(langWrongPreset);
		myDialog.destroy();
		exit();
	}
//Определяем число повторов	
	var myInteration = 0;
//Для каждого абзаца текста
	for (myCounter = 0; myCounter < myStory.paragraphs.length; myCounter++) {
		if ((myStory.paragraphs[myCounter].parent.constructor.name != "Cell") && (myStory.paragraphs[myCounter].appliedParagraphStyle.name == myStyle)) {
//Табулируем
			var myTable = myPreset.applyPreset(myStory.paragraphs[myCounter], mySelectSpaceBefore, mySelectSpaceAfter);
			myInteration++;
			if ((myInteration > iniInteration) && iniSaveDocumentOnInteration) {
				myDoc.save(myDoc.fullName);
			}
		}
	}
	if (iniSaveDocumentOnEnd) {
		myDoc.save(myDoc.fullName);
	}
//	var myContinue = confirm('Продолжаем?'); // *** Спрашиваем ***
//	} while (myContinue); // *** Шабаш если отказываемся ***
	}
myDialog.destroy();
exit();
}